@setlocal enableextensions enabledelayedexpansion
@echo off
set stime=%time:~0,2%%time:~3,2%%time:~6,2%
set shutdownPC=0
CLS
echo *******************************************************************************
echo ***************                  BACKUP SCRIPT                  ***************
echo ***************          created by Daniel Mieszkowski          ***************
echo ***************             d.mieszkowski@pcmagic.pl            ***************
echo *******************************************************************************
echo.
echo Dyski lokalne:
for /f "tokens=1" %%d in (
 'wmic logicaldisk get deviceid ^| find ":"') do ( 
    for /f "usebackq delims== tokens=2" %%x in (`wmic logicaldisk where "DeviceID='%%d'" get Size /value`) do set Size=%%x
    for /f "usebackq delims== tokens=2" %%x in (`wmic logicaldisk where "DeviceID='%%d'" get FreeSpace /value`) do set FreeSpace=%%x
    echo %%d - dostepne !FreeSpace:~0,-10!,!FreeSpace:~2,-8!GB / !Size:~0,-10!,!Size:~2,-8!GB
    )
)
echo.
set /p sourceDrive= Kopiowany dysk (domyslnie D): 
set /p destDrive= Nosnik zapasowy (domyslnie B): 
echo.

IF [%sourceDrive%] EQU [] SET sourceDrive=D
IF [%destDrive%] EQU [] SET destDrive=B

set destWinDrive=%destDrive%:\
set destCwDrive=/cygdrive/%destDrive%/

set sourWinDrive=%sourceDrive%:\
set sourCwDrive=/cygdrive/%sourceDrive%/

set backup_dest=Backup_drive_%sourceDrive%
set RSYNC_param=-aPh
set EXECUTE=wykluczenia.txt
set sources=
set source=%sources%

IF NOT EXIST %destWinDrive%%backup_dest% GOTO :sub_DestdirNotExist
IF NOT EXIST %sourWinDrive% GOTO :sub_SrcdirNotExist

:sub_getLatestBackup
:: pozyskanie ostatniego folderu z backupem
FOR /F "delims=" %%i IN ('dir %destWinDrive%%backup_dest% /b /ad-h /t:c /od') DO SET last_backup=%%i
::echo %destWinDrive%%backup_dest%%last_backup%
IF [%last_backup%] NEQ [] SET last_backup_param=--link-dest=%destCwDrive%%backup_dest%/%last_backup%/
IF [%last_backup%] NEQ [] SET last_backupString=%destWinDrive%%backup_dest%\%last_backup%
set stime=%stime: =0%
IF [%last_backup%] EQU [] SET last_backupString=none
echo.
echo Parametery:
echo ---------------------------
echo    Ostatnia kopia: %last_backupString%
echo            Zrodlo: %sourWinDrive%%sources%
echo  Miejsce docelowe: %destWinDrive%%backup_dest%\%date%_%stime%
echo ---------------------------

:sub_choice
echo.
echo 1 = Wykonaj kopie
echo 2 = Wykonaj kopie i wylacz komputer
echo 3 = Anuluj
echo.
set /p myVar= Wpisz numer wybranej opcji: 
if "%myVar%" == "1" goto :sub_makeCopy
if "%myVar%" == "2" goto :sub_makeCopyAndClose
if "%myVar%" == "3" goto :sub_end
goto :sub_choice


:sub_makeCopyAndClose
set shutdownPC=1

:sub_makeCopy
cwRsync\rsync %RSYNC_param% --progress --exclude-from %EXECUTE% --log-file=%destCwDrive%%backup_dest%/%date%_%stime%log.txt %last_backup_param% -del %sourCwDrive%%sources% %destCwDrive%%backup_dest%/%date%_%stime%
if "%shutdownPC%" == "1" goto :sub_shutdownPC
goto :sub_pause

:sub_shutdownPC
shutdown /s /t 1
goto :sub_end

:sub_DestdirNotExist
echo.
echo Tworzenie folderu ('%destWinDrive%%backup_dest%')
mkdir %destWinDrive%%backup_dest% 
goto :sub_getLatestBackup

:sub_SrcdirNotExist
echo.
echo Ostrzezenie!
echo katalog '%sourWinDrive%' nie istnieje. sprawdz ustawienia
echo.
goto :sub_pause

:sub_pause
@pause
goto :sub_end

:sub_end


